//Franky Alfaro 5-20-2012

/* This program creates a message for the self destructing message. The user
   can change the contents of the "mission" array. A max of 256 characters can 
   be used per page of FM24c04 FRAM memory. Default is one page. When the program 
   is run,the "Mission Objective" will be written to the FM24c04 memory, and the
   message can be view in the Serial Monitor, to ensure your message appears as
   desired.
   Good Luck on your Mission.
   -------------------------------------------------------------------------
*/

#include <Wire.h>

//Function Prototype
void write_ramtrom();

/* This is the address of the FM24c04. 1010 is the device type. The following two bits,
   00, are the device address, which depend on how A2 and A1 are connected(Pins 3 and 2).
   Tied to VCC, it will be a high bit, tied to ground, a low bit. "These pins are internally
   pulled down". The last bit is the page address, to access the lower/upper adress range.
*/
int ramtron = B1010000; 

int array_size = 76; // Set this to the size of the "mission" character array
int first_word = B00000000; //first available address 
char mission[] = "Your Mission, Should you choose to accept it,  is to enter the SPY Challenge"; //character array to write to memory

///// ***END DECLARE*** /////////////
/////////////////////////////////////

void setup()
{
  Wire.begin();     // Arduino joins the i2C bus as a master
  Serial.begin(9600); // starts the serial @ 9600 baud
  write_ramtron();
  read_ramtron();
}
///// ***END SETUP*** //////////////
///////////////////////////////////

void loop()
{
}
///// ***END LOOP***////////////////
///////////////////////////////////

void write_ramtron()
{
  Serial.println("Writing to memory");
  int first =0;
  for(int i=0; i<array_size; i++)
  {
  Wire.beginTransmission(ramtron); // start talking to device with address "ramtron" 
  Wire.send(first); 
  
  //loop to fill memory with char array "love"
 
        
              Wire.send(mission[first]); //sends once character from array 
              Wire.endTransmission(); // stop talking to the device
              first = first+1;
            }
      
 delay(1000); // delay one second
}
///// ***END WRITE_RAMTRON*** ///////////////////////////
////////////////////////////////////////////////////////

void read_ramtron()
{
  /*This small square of code looks like a write function, but it serves the purpose of 
    setting the internal address latch to the desired adress to read. a write function
    is sent to the FM24c04, but before any data is written to the chip, a Wire.endTransmission
    terminates the write. The latch is left at this address, and a read function can follow,
    picking up at the address that follows
  */
  ///////////////////////////////////////////////////////////////////////////////////////////
  Serial.println("begin Mission briefing:");
  delay(1000);
  Wire.beginTransmission(ramtron); // start talking device with address "ramtron" (int)
  Wire.send(first_word);
  Wire.endTransmission();
  ////////////////////////////////////////////////////////////////////////////////////////////
  Wire.beginTransmission(ramtron);
  
  //loop to read memory
  
        for(int j=0; j<array_size; j++)
            {
              Wire.requestFrom(ramtron, 1);
              Serial.print(char(Wire.receive()));
            }
            Serial.println("\n");
            Serial.println("End Mission Briefing");
            
           
  delay(2000);
}
///// ***END READ_RAMTRON*** /////////////
/////////////////////////////////////////

